config/routes.rb
Rails.application.routes.draw do
  root to: 'dashboard#show'
  get 'locked' => 'pages#locked', as: :locked_screen
  get 'thankyou' => 'pages#thankyou', as: :thankyou_screen

  devise_for :staffs
  devise_for :users

  resources :tickets do
    member do
      put :feedback_submit
    end
    collection do
      get :search
    end
    resources :comments
  end

  resources :todos
  resources :products do
    collection do
        get :search
      end
  end
  resources :quotes
  resource :account, controller: :account
  resource :staff_account, controller: :staff_account
  resources :notifications do
    collection do
      put :mark_as_read
    end
  end

  namespace :manager do
    resource :dashboard, controller: :dashboard do
      collection do
        get :chart_data
      end
    end
    resources :users
  end
 

  namespace :admin do
    resources :staffs
    
  end

  namespace :guest do
    resources :tickets
  end
  
  namespace :staff do
    resources :quotes do
      member do
        post :create_ticket
      end
    end



    resource :dashboard, controller: :dashboard do
      collection do
        get :chart_data
      end
    end
    resources :tickets do
      member do
        put :feedback_submit
      end
      collection do
        get :search
      end
    end
    resources :clients do
      resources :users do
      collection do
        get :search
      end
    end
 
    end
  end

end

app/models/staff.rb
class Staff < ApplicationRecord
  ROLES = {'engineer' => 'Engineer', 'admin' => 'Admin'}
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable

  has_many :tickets
  has_many :todos, as: :creator
  has_many :comments, as: :creator
  has_many :notifications, as: :notifiable
  has_attached_file :photo, styles: { medium: "300x300>", thumb: "100x100>" }, default_url: "/images/:style/noimg.png"
  validates_attachment_content_type :photo, content_type: /\Aimage\/.*\z/

  ROLES.each do |k, v|
    define_method "is_#{k}?" do
      role == k
    end
  end
end

app/controllers/admin/staffs_controller.rb
class Admin::StaffsController < Admin::BaseController

  def new
    @staff = Staff.new 
  end

  def edit
    @staff= Staff.find(params[:id])
  end

  def update
    @staff= Staff.find(params[:id])
    if @staff.update_attributes(staff_params)
      flash[:success]="Successfully updated"
      redirect_to admin_staffs_path(@staff)
    else
      render 'edit'
    end
  end

  def index
     @staffs = Staff.where(is_deleted: false).order(name: :asc)
  end

  def destroy
    @staff= Staff.find(params[:id])
    @staff.update_attributes is_deleted: true
    redirect_to admin_staffs_path
  end

  def create
    @staff = Staff.new(staff_params)
    if @staff.save
      redirect_to admin_staffs_path
    else
      render action: 'new'
    end
  end

  private
    def staff_params
      params.require(:staff).permit(:name, :email, :password, :password_confirmation, :role, :is_deleted).tap do |p|
        if p[:password].empty? and p[:password_confirmation].empty?
          p.delete :password
          p.delete :password_confirmation
        end
      end
    end
end

app/controllers/guest/tickets_controller.rb
class Guest::TicketsController < ApplicationController
  
  layout 'guest'
  def new
    @ticket = Ticket.new
  end

  def create
    @ticket = Ticket.new(ticket_params)
    Ticket.with_performer nil do
      if verify_recaptcha(model: @ticket) && @ticket.save
        flash[:success]="Thank you"
        redirect_to new_user_session_path
      else
        render action: 'new'
      end
    end
  end

  private
    def ticket_params
      params.require(:ticket).permit(:name,:email, :subject, :description, :attachment).tap do |p|
        p[:is_guest] = true
        p[:priority] = 'low'
      end
    end

end

app/controllers/staff/base_controller.rb
class Staff::BaseController < ApplicationController
  before_action :authenticate_staff!
end

app/controllers/staff/clients_controller.rb
class Staff::ClientsController < ApplicationController

  def new
    @client = Client.new 
  end

  def index
    @clients = Client.where(is_deleted: false).order(name: :asc)
  end

  def edit
    @client= Client.find(params[:id])
  end
  
  def create
    @client = Client.new(client_params)
    if @client.save
      redirect_to staff_clients_path
    else
      render action: 'new'
    end
  end

  def update
    @client= Client.find(params[:id])
    if @client.update_attributes(client_params)
      flash[:success]="Successfully updated"
      redirect_to staff_client_path(@client)
    else
      render 'edit'
    end
  end

  def show
    @client= Client.find(params[:id])
     @users = @client.users.where(is_deleted: false).order(name: :asc)
    @user = User.new
  end

  def destroy
    @client= Client.find(params[:id])
    @client.is_deleted = true
    @client.save
    redirect_to staff_clients_path
  end

  private
    def client_params
      params.require(:client).permit(:name, :address, :logo, :phone, :email, :website, :is_deleted)
    end
    
end

app/controllers/staff/dashboard_controller.rb
class Staff::DashboardController < Staff::BaseController

  def show
    @tickets =Ticket
    @todos = current_staff.todos.where(is_completed: false).order(created_at: :asc)
  end
  
  def chart_data
    data = prepare_data(tickets_scope)
    colors = data_colors[0..data.count-1]

    op = {
      labels: data.keys,
      datasets: [{
        label: "Ticket Stats",
        data: data.values,
        backgroundColor: colors,
        hoverBackgroundColor: colors
      }]
    }

    render json: JSON.dump(op)
  end

  private
  def tickets_scope
    tickets = Ticket
    tickets = case params[:filter]
    when 'open'
      tickets.open
    when 'overdue'
      tickets.where("status=? and expected_closing_date < ?", "in_progress", Date.today)
    when 'in_progress'
      tickets.where(status: "in_progress")
    when 'due_today'
      tickets.where("status != ? and expected_closing_date = ?", "closed", Date.today)
    when 'unassigned'
      tickets.where(staff: nil)
    when 'closed'
      tickets.where(status: "closed")
    else
      tickets
    end

    tickets
  end

  def prepare_data(scope)
    op = {}
    Ticket::CATEGORIES.each do |c|
      count = scope.where(category: c).count
      op[c] = count if count > 0
    end
    if (count = scope.where('category IS NULL OR category NOT IN (?)', Ticket::CATEGORIES).count) > 0
      op['Others'] = count
    end

    op
  end

  def data_colors
    [
      "#222222",
      "#b8b8b8",
      "#00dac7",
      "#5C5C5C",
      "#ff5252",
      "#2196F3",
      "#4CAF50",
      "#FF0084",
      "#f57c00"
    ].shuffle
  end
end

app/controllers/staff/quotes_controller.rb
class Staff::QuotesController < ApplicationController

  def create_ticket
    quote = Quote.find params[:id]
    if !quote.ticket_id.present?
      Ticket.with_performer current_staff do
        ticket = Ticket.new
        ticket.name = quote.name
        ticket.subject = "Quote from #{quote.name}"
        ticket.user_id = quote.user_id
        ticket.priority = 'medium'
        ticket.description = quote.description
        ticket.source = quote.preferred_method
        ticket.save!
        quote.ticket_id = ticket.id
        quote.save
      end
      redirect_to staff_tickets_path
    end
  end

  def index
    @quotes = Quote.all.order(id: :desc)
  end

  def show
    @quote = Quote.find params[:id]
  end
  
end

app/controllers/staff/tickets_controller.rb
class Staff::TicketsController < Staff::BaseController

  def new
    @ticket = current_staff.tickets.new(priority: 'low', name: current_staff.name)
  end

  def create
    Ticket.with_performer current_staff do
      @ticket = current_staff.tickets.new(t_params)
      if @ticket.save
        redirect_to staff_tickets_path
      else
        render action: 'new'
      end
    end
  end


  def index
    @tickets =Ticket.all.order(id: :desc)
    if params[:status].present?
      if params[:status] == "unassigned"
        @tickets = Ticket.where(staff_id: nil)
      elsif params[:status] == "overdue"
        @tickets = @tickets.where("status != ? and expected_closing_date < ?", "closed", Date.today)
      elsif params[:status] == "due_today"
        @tickets = @tickets.where("status != ? and expected_closing_date = ?", "closed", Date.today)
      elsif
        @tickets = @tickets.where(status: params[:status])
      end
    else
      @tickets = @tickets.where(status: nil)
    end
    respond_to do |format|
      format.html
      format.csv do
        headers['Content-Disposition'] = "attachment; filename=\"tickets-list.csv\""
        headers['Content-Type'] ||= 'text/csv'
      end
      format.pdf do
        render pdf: "tickets-list", disposition: 'attachment', layout: 'pdf'
      end
    end
  end

  def show
    @ticket = Ticket.find params[:id]
    @quote = Quote.find_by_ticket_id(@ticket.id) 
    @staffs = Staff.all
  end

  def update
    @ticket = Ticket.find params[:id]
    Ticket.with_performer current_staff do
      @ticket.update_attributes! ticket_params
    end
    
    redirect_to staff_ticket_path(@ticket)
  end

  def feedback_submit
    @ticket = Ticket.find params[:id]
    Ticket.with_performer current_user do
      @ticket.update_attributes(feedback_params)
      params[:success] = 'Feedback received'
      redirect_to ticket_path(@ticket)
    end
  end

  def search
    @tickets = Ticket.where("1=1")
    @tickets = @tickets.where(status: params[:search][:status]) if params[:search][:status].present?
    @tickets = @tickets.where(staff_id: params[:search][:staff_id]) if params[:search][:staff_id].present?
    @tickets = @tickets.where(priority: params[:search][:priority]) if params[:search][:priority].present?
    @tickets = @tickets.where(category: params[:search][:category]) if params[:search][:category].present?
    @tickets = @tickets.joins(:user).where("users.client_id": params[:search][:client_id]) if params[:search][:client_id].present?

    if params[:search][:query].present?
      query = '%' + params[:search][:query] + '%'
      @tickets = @tickets.where("name LIKE ? OR subject LIKE ?", query, query)
    end

    render action: :index
  end

  private
    def ticket_params
      op = params.require(:ticket).permit(:status, :priority, :staff_id)
      op[:status] = nil if op[:status] == ""
      op
    end

    def t_params
      params.require(:ticket).permit(:name, :subject, :description, :priority, :attachment,:category, :source, :service_type, :user_id, :expected_closing_date)
    end

    def feedback_params
      params.require(:ticket).permit(:feedback_score, :feedback_comment)
    end
end

app/controllers/staff/users_controller.rb
class Staff::UsersController < ApplicationController

  def new
    @user = User.new 
    @client= Client.find(params[:client_id])
  end

  def show
    @client= Client.find(params[:client_id])
    @user = User.find(params[:id])
  end

  def edit
    @user = User.find(params[:id])
    @client= Client.find(params[:client_id])
  end

  def update
    @client= Client.find(params[:client_id])
    @user= User.find(params[:id])
      if @user.update_attributes(user_params)
        flash[:success]="Successfully updated"
        redirect_to staff_client_user_path()
      else
        render 'edit'
    end
  end

  def create
    @client= Client.find(params[:client_id])
    @user = User.new(user_params)
    @user.client_id = @client.id
    if @user.save
      redirect_to staff_client_path(@client)
    else
      render action: 'new'
    end
  end

  def search
  @client= Client.find(params[:client_id])
  @users = User.where(client_id: @client.id)
  if params[:search][:query].present?
    query = '%' + params[:search][:query] + '%'
    @users = @users.where("name LIKE ? OR email LIKE ?", query, query)
  end
  render template: 'staff/clients/show'
  end

  def destroy
    @client= Client.find(params[:client_id])
    @user = User.find(params[:id])
    @user.is_deleted = true
    @user.save
    redirect_to staff_client_path(@client)
  end

  private
    def user_params
      op = params.require(:user).permit(:photo, :name, :email, :password, :password_confirmation, :role, :is_deleted)
      if op[:password].blank? and op[:password_confirmation].blank?
        op.delete :password
        op.delete :password_confirmation
      end
      return op
    end
    
end

app/controllers/tickets_controller.rb
class TicketsController < ApplicationController

  before_action :authenticate_user!

  def new
    @ticket = current_user.tickets.new(priority: 'low', name: current_user.name)
  end

  def create
    Ticket.with_performer current_user do
      @ticket = current_user.tickets.new(ticket_params)
      if @ticket.save
        redirect_to tickets_path
      else
        render action: 'new'
      end
    end
  end

  def index
    if current_user.is_manager?
      @tickets = Ticket.joins(:user).where("users.client_id": current_user.client_id)
    else
      @tickets = Ticket.where(user_id: current_user.id)
    end
    
    if params[:status].present?
      if params[:status] == "unassigned"
        @tickets = Ticket.where(staff: nil)
      elsif params[:status] != "all"
        @tickets = @tickets.where(status: params[:status])
      end
    else
      @tickets = @tickets.where(status: nil).order(id: :desc)
    end
    respond_to do |format|
      format.html
      format.csv do
        headers['Content-Disposition'] = "attachment; filename=\"tickets-list.csv\""
        headers['Content-Type'] ||= 'text/csv'
      end
      format.pdf do
        render pdf: "tickets-list", disposition: 'attachment', layout: 'pdf'
      end
    end
  end

  def show
    @ticket = Ticket.find params[:id]
  end

  def search
    @tickets = Ticket.where(user_id: current_user.id)
    @tickets = @tickets.where(status: params[:search][:status]) if params[:search][:status].present?
    @tickets = @tickets.where(staff_id: params[:search][:staff_id]) if params[:search][:staff_id].present?
    @tickets = @tickets.where(priority: params[:search][:priority]) if params[:search][:priority].present?

    if params[:search][:query].present?
      query = '%' + params[:search][:query] + '%'
      @tickets = @tickets.where("name LIKE ? OR subject LIKE ?", query, query)
    end
    render action: :index
  end

  def feedback_submit
    @ticket = Ticket.find params[:id]
    Ticket.with_performer current_user do
      @ticket.update_attributes(feedback_params)
      params[:success] = 'Feedback received'
      redirect_to ticket_path(@ticket)
    end
  end

  private
    def ticket_params
      params.require(:ticket).permit(:name, :subject, :description, :priority, :attachment,:category, :source, :service_type, :expected_closing_date)
    end

    def feedback_params
      params.require(:ticket).permit(:feedback_score, :feedback_comment)
    end

end

app/helpers/admin/staff_helper.rb
module Admin::StaffHelper
end

app/helpers/agent/tickets_helper.rb
module Agent::TicketsHelper
end

app/helpers/guest/tickets_helper.rb
module Guest::TicketsHelper
end

app/helpers/staff/clients_helper.rb
module Staff::ClientsHelper
end

app/helpers/staff/quotes_helper.rb
module Staff::QuotesHelper
end

app/helpers/staff/users_helper.rb
module Staff::UsersHelper
end

app/helpers/tickets_helper.rb
module TicketsHelper
end

app/views/staff/tickets/index.csv.erb
 List of tickets as on <%= Time.now.strftime(TIME_FORMAT1) %>

<%- headers = ['Name', 'Subject', 'Status', 'Priority', 'Created Date'] -%>
<%= CSV.generate_line headers %>
<%- @tickets.each do |ticket| -%>
<%= CSV.generate_line([ticket.name, ticket.subject, ticket.status, ticket.priority, ticket.created_at]) -%>
<%- end -%>

app/views/staff/tickets/index.html.erb
<div class="container-fluid">
  <div class="p-t-30">
    <div class="row">
      <div class="col-sm-12">
        <div class="card">
          <div class="card-header">
            <h5 class="card-header-text">tickets(<%= @tickets.count %>) </h5>
            <div class = "dropdown-primary dropdown f-right">
              <button type="button" class="btn btn-inverse-primary waves-effect waves-light dropdown-toggle" data-toggle="dropdown" data-placement="top" title="" data-original-title=".btn-inverse-primary">Export
              </button>
              <div class = "dropdown-menu dropdown-menu-right" role = "menu">
                <%= link_to 'CSV', staff_tickets_path(format: :csv, status: params[:status]), class: 'dropdown-item waves-light waves-effect' %>
                <%= link_to 'PDF',staff_tickets_path(format: :pdf, status: params[:status]), class: 'dropdown-item waves-light waves-effect' %>
              </div>
            </div>
          </div>
          <div class="card-block">
          <%= form_for OpenStruct.new(params[:search]), as: :search, url: search_staff_tickets_path, method: :get do |f| %>
            <div class="row">
              <div class="col-xl-2">
                <%= f.select :staff_id, Staff.all.collect{|s| [s.name, s.id]}, {:prompt => '-- Assigned to --'} %>
              </div>
              <div class="col-xl-1">
                <%= f.select :client_id, Client.all.collect{|c| [c.name, c.id]}, {:prompt => '-- Client --'} %>
              </div>
              <div class="col-xl-2">
                <%= f.select :status, Ticket::STATUSES.collect{|k,v| [v, k]}, {:prompt => '-- Status --'} %>
              </div>
              <div class="col-xl-2">
                <%= f.select :priority, Ticket::PRIORITIES, {:prompt => '-- Priorities --'} %>
              </div>
              <div class="col-xl-2">
                <%= f.select :priority, Ticket::CATEGORIES, {:prompt => '-- Category --'} %>
              </div>
              <div class="col-xl-2">
                <%= f.text_field :query %>
              </div>
              <div class="col-xl-1">
                <%= submit_tag "Search"%>
              </div>
            </div>
            <% end %>
              <br />
              <% if @tickets.present? %>
                <div class="table-content p-l-20 p-r-20 p-b-20">
                  <table class="table">
                    <thead>
                      <tr role="row">
                        <th>
                          <div class="rkmd-checkbox checkbox-rotate">
                            <label class="input-checkbox checkbox-primary">
                                <input type="checkbox" id="checkbox32">
                                <span class="checkbox"></span>
                            </label>
                            <div class="captions"></div>
                          </div>
                        </th>
                        <th>#ID</th>
                        <th>Subject</th>
                        <th>Status</th>
                        <th>Priority</th>
                        <th>User / Client</th>
                        <th>Assigned To</th>
                        <th>Created Date</th>
                      </tr>
                    </thead>

                    <tbody>
                      <% @tickets.each do |ticket| %>
                        <tr class="ticket-<%= ticket.status %>">
                          <td>
                            <div class="rkmd-checkbox checkbox-rotate">
                                <label class="input-checkbox checkbox-primary">
                                    <input type="checkbox" id="checkbox32">
                                    <span class="checkbox"></span>
                                </label>
                                <div class="captions"></div>
                            </div>
                          </td>
                          <td><%= ticket.id %></td>
                          <td><%= link_to ticket.subject, staff_ticket_path(ticket) %></td>
                          <td><%= Ticket::STATUSES[ticket.status] %></td>
                          <td><%= ticket.priority %></td>
                          <td>
                            <% if ticket.is_guest? %>
                              Guest
                            <% else %>
                              <%= ticket.user.name %> / <%= ticket.user.client.name  %>
                            <% end %>
                          </td>
                          <td><%= ticket.staff.try :name %></td>
                          <td><%= ticket.created_at.strftime TIME_FORMAT1 %></td>
                          <td>
                          </td>
                        </tr>
                      <% end %>
                    </tbody>
                  </table>
                </div>
              <% else %>
                <div class="card-header">
                  <center class="p-t-50 p-b-50">
                     Sorry you don't have any Tickets
                    <br />
                    <br />
                  </center>
                </div>
            <% end %>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>

app/views/staff/tickets/index.pdf.erb
<h3>Tickets</h3>
<table class="table" border='1'>

  <thead>
    <tr role="row">
      <th>#ID</th>
      <th>Name</th>
      <th>Subject</th>
      <th>Status</th>
      <th>Priority</th>
      <th>Created Date</th>
    </tr>
  </thead>

  <tbody>
    <% @tickets.each do |ticket| %>
      <tr>
        <td><%= ticket.id %></td>
        <td><%= ticket.name %></td>
        <td><%= ticket.subject %></td>
        <td><%= Ticket::STATUSES[ticket.status] %></td>
        <td><%= ticket.priority %></td>
        <td><%= ticket.created_at.strftime TIME_FORMAT1 %></td>
      </tr>
    <% end %>
  </tbody>
  
</table>

app/views/staff/tickets/show.html.erb
<div class="container-fluid ticket-show">
  <div class="p-t-30">
    <h4>Ticket #<%= @ticket.id %></h4>

    <ol class="breadcrumb breadcrumb-title breadcrumb-arrow">
      <li class="breadcrumb-item">
        <i class="icofont icofont-home"></i>
      </li>
      <li class="breadcrumb-item">
        View Ticket
      </li>
    </ol>

    <hr />
    <div >
      Subject : <%= @ticket.subject %>
      <br />
      Created by : <%= @ticket.is_guest? ? @ticket.email : @ticket.user.email %>
    </div>
    <br />

    <div class="row">
      <div class="col-md-9 default-grid-item">
        <div class="card">
          <div class="card-block">
            <ul class="nav nav-tabs  tabs" role="tablist">
              <li class="nav-item">
                <a class="nav-link active" data-toggle="tab" href="#home1" role="tab">Ticket Details</a>
              </li>
              <li class="nav-item">
                <a class="nav-link" data-toggle="tab" href="#profile1" role="tab">Audit log</a>
              </li>
              <li class="nav-item">
                <a class="nav-link" data-toggle="tab" href="#messages1" role="tab">Feedback</a>
              </li>
            </ul>
            <br />
            <div class="tab-content tabs">
              <div class="tab-pane active" id="home1" role="tabpanel">
                <div class="row">
                  <div class="col-xl-4">
                    Created Date : <%= @ticket.created_at.strftime(DATE_FORMAT1) %>
                  </div>
                  <div class="col-xl-4">
                    Modified Date : <%= @ticket.updated_at.strftime(DATE_FORMAT1) %>
                  </div>
                  <div class="col-xl-4">
                    Status : <%= Ticket::STATUSES[@ticket.status] %>
                  </div>
                </div>
                <br />
                <div class="row">
                  <div class="col-xl-4">
                    Priority : <%= @ticket.priority %>
                  </div>
                  <div class="col-xl-4">
                    Assigned to : <%= @ticket.staff.try :name %>
                  </div>
                  <div class="col-xl-4">
                    <% if @ticket.attachment_file_name.present? %>
                      Attachment : <%= link_to @ticket.attachment_file_name, @ticket.attachment.url, target: "_blank" %>
                    <% end %>
                  </div>
                </div>
                <br />
                <div class="row">
                  <div class="col-xl-4">
                    Response Time : 
                  </div>
                  <div class="col-xl-4">
                    Resolution Time : 
                  </div>
                  <div class="col-xl-4">
                    <% if @ticket.expected_closing_date.present? %>
                      Expected Closure : <%= @ticket.expected_closing_date.strftime DATE_FORMAT1 %>
                    <% end %>
                  </div>
                  <br />
                  <br />
                </div>
                <% if @quote.present? %>
                <div class="row">
                  <div class="col-xl-8">
                    <table class='table'>
                      <tr>
                        <th>Product</th>
                        <th>Quantity</th>
                      </tr>
                      <% (@quote.product || []).each do |p| %>
                        <tr>
                          <td><%= p['type'] %></td>
                          <td><%= p['quantity'] %></td>
                        </tr>
                      <% end %>
                    </table>
                  </div>
                  <div class="col-xl-4">
                  </div>
                </div>
                <% end %>
                <div class="m-t-20">
                  <div class="card">
                    <div class="card-block">
                      <div class="row">
                        <div class="col-xl-1 photo-table">
                          <%= image_tag 'avatar-1.png',  class: 'img-circle' %>
                        </div>
                        <div class="col-xl-4">
                          <% if @ticket.is_guest? %>
                            Client: Guest
                            <br />
                            Created by: <%= @ticket.name %>
                          <% else %>
                            Client : <%= @ticket.user.client.name %>
                            <br />
                            Created by : <%= @ticket.user.name %>
                          <% end %>
                        </div>
                        <div class="col-xl-3">
                        </div>
                        <div class="col-xl-4">
                          Posted on: <%= @ticket.created_at.strftime(TIME_FORMAT1) %>
                        </div>
                      </div>
                      <br />
                      <%= @ticket.description.html_safe %>
                    </div>
                  </div>
                  <% @ticket.comments.each do |comment| %>
                    <div class="cd-timeline-content card_main" id="comment-<%= comment.id %>">
                      <div class="card-block">
                        <div class="row">
                          <div class="col-xl-1 photo-table">
                            <%= image_tag 'avatar-1.png',  class: 'img-circle' %>
                          </div>
                          <div class="col-xl-4">
                              <%= comment.creator.try :name %>
                          </div>
                          <div class="col-xl-3">
                          </div>
                          <div class="col-xl-4">
                            Posted on: <%= comment.created_at.strftime(TIME_FORMAT1) %>
                          </div>
                        </div>
                        <br />
                        <%= comment.description.html_safe %>
                      </div>
                    </div>
                  <% end %>
                  <%= render 'comments/new', comment: @ticket.comments.new(creator: current_staff) %>
                </div>
              </div>
              <div class="tab-pane" id="profile1" role="tabpanel">
                <%= render "ticket_logs/index", ticket_logs: @ticket.ticket_logs.order(created_at: :desc) %>
              </div>
              <div class="tab-pane" id="messages1" role="tabpanel">
                <%= form_for @ticket, url: feedback_submit_staff_ticket_path(@ticket), method: :put do |f| %>
                  <%= render 'tickets/feedback_form', f: f %>
                <% end %>
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="col-md-3 default-grid-item p-t-50">
        <div class="p-t-20">
          <div class="cd-timeline-content card_main">
            <div class="card-block">
              <%= form_for @ticket, url: staff_ticket_path(@ticket), method: :put do |f| %>
                <table class="table table-striped">
                  <tr>
                    <th>Customer</th>
                    <td>
                      <% if @ticket.is_guest? %>
                        <%= @ticket.name %> (Guest)
                      <% else %>
                        <%= @ticket.user.name %>
                      <% end %>
                    </td>
                  </tr>
                  <tr>
                    <th>Status</th>
                    <td><%= f.select :status, options_for_select(Ticket::STATUSES.collect{|k,v| [v, k]}, selected: f.object.status) %></td>
                  </tr>
                  <tr>
                    <th>Priority</th>
                    <td><%= f.select :priority, options_for_select(Ticket::PRIORITIES, selected: f.object.priority) %></td>
                  </tr>
                  <tr>
                    <th>Assigned to</th>
                    <td><%= f.select :staff_id, options_for_select([['None', nil]] + @staffs.collect{|a| [a.name, a.id]}, selected: f.object.staff_id) %></td>
                  </tr>
                  <tr>
                    <td colspan='2' class='text-center'><%= f.submit 'Update', class: 'btn btn-primary' %></td>
                  </tr>
                </table>
              <% end %>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>